﻿using System;
using static XFUDriver.XFUDriver;

namespace IO_CSharp
{
    partial class Program
    {
        [System.Runtime.InteropServices.DllImport("Kernel32.dll", SetLastError = true, CharSet = System.Runtime.InteropServices.CharSet.Auto, CallingConvention = System.Runtime.InteropServices.CallingConvention.Cdecl)]
        static extern uint SetFilePointer(Microsoft.Win32.SafeHandles.SafeFileHandle hFile, int lDistanceToMove, ref int lpDistanceToMoveHigh, UInt32 dwMoveMethod);


        [System.Runtime.InteropServices.DllImport("kernel32", SetLastError = true)]
        static extern bool ReadFile
        (
            Microsoft.Win32.SafeHandles.SafeFileHandle hFile,      // handle to file
            byte[] pBuffer,            // data buffer
            int NumberOfBytesToRead,  // number of bytes to read
            ref UInt32 pNumberOfBytesRead,  // number of bytes read
            int Overlapped            // overlapped buffer
        );

        [System.Runtime.InteropServices.DllImport("kernel32", SetLastError = true)]
        static extern bool CloseHandle(Microsoft.Win32.SafeHandles.SafeFileHandle hFile);

        [System.Runtime.InteropServices.DllImport("kernel32.dll", CharSet = System.Runtime.InteropServices.CharSet.Ansi, SetLastError = true)]
        static extern Microsoft.Win32.SafeHandles.SafeFileHandle CreateFileA(string filename, uint access, uint share, uint securityAttributes, uint creationDisposition, uint flagsAndAttributes, IntPtr templateFile);

        [System.Runtime.InteropServices.DllImport("kernel32.dll")]
        static extern uint GetFileSize(Microsoft.Win32.SafeHandles.SafeFileHandle hFile, out int lpFileSizeHigh);
       

        static int FoEDownload(byte slave, string filename, UInt32 password, UInt32 filesize, UInt16 blocksize, Microsoft.Win32.SafeHandles.SafeFileHandle fd, UInt32 timeout)
        {
            int i = 0;
            UInt32 j = 0; ;
            int lpDistanceToMoveHigh = 0;
            byte[] buf = new byte[256];
            int bsize = blocksize & ~3;
            UInt32 fsize = 0;
            if (fd.IsInvalid)
                return -1;
            // SetFilePointer(fd, 0, ref lpDistanceToMoveHigh, 0 /*FILE_BEGIN*/);
            while (filesize > j)
            {
                if ((j + bsize) > filesize)
                {
                    bsize = (int)(filesize - j);
                }
                Boolean isReadFileSuccess;
                isReadFileSuccess = ReadFile(fd, buf, bsize, ref fsize, 0);
                if (isReadFileSuccess == false)
                    break;
                System.Threading.Thread.Sleep(1000);
                i = ECM_EcatFoEDataWrite(j, fsize, buf); // fsize must <= 256, SPI dataSize must >= fsize (File to XF Chip via SPI/USB)
                if (i < 0)
                    return i;
                j += (UInt32)(((uint)fsize + 3) & ~3);
                Console.WriteLine(String.Format("{0} / {1}", j, filesize)); // j must be a multiple of 4
            }
            i = ECM_EcatFoEDownload(slave, filename, password, filesize, 0, 10000000); // File from XF IC to slave via FoE
            return i;
        }
        static byte[] g_u8RxPDO = new byte[1400];
        static byte[] g_u8TxPDO = new byte[1400];
        static void Main(string[] args)
        {
            #region Init
            int nRet = 0;
            byte u8Version = 0, u8TmpEcState = 0, u8CrcErrCnt = 0, u8FifoCnt = 0, u8WkcErrCnt = 0, u8IsSlvAlive = 0;
            byte u8TxFIFOCnt = 64, u8RxFIFOCnt = 64;
            ushort u16RxPDOSize, u16TxPDOSize;
            uint u32InfoBuf = 0;
            sbyte nSlvCntOnline;
            int bLinkPin = -1;
            ushort u16SpiSize = 992;

            XF_SetDevType(0);   // 第一個參數為 0 for USB, 1 for PCIe

            nRet = UserSys_Init(24000000);
            if (nRet < 0)
            {
                Console.WriteLine("UserSys_Init return {0} Any key to exit.", nRet);
                Console.ReadKey();
                return;
            }
            u8Version = ECM_InitLibrary(ref u16SpiSize, ECM_CRC_TYPE.NONE);
            Console.WriteLine("u8Version 0x{0:X}", u8Version); //IC內部韌體版本
            if (u8Version == 0)
                return;
            nRet = ECM_GetNetLinkPin(ref bLinkPin);
            Console.WriteLine("ECM_GetNetLinkPin linkpin = {0}, ret={1}", bLinkPin, nRet); //linkpin=0 代表網路接口沒有連結

            nRet = ECM_EcatInit(0x0, 1000000); // 第一個參數0x300代表DC Sync, 0代表Free Run (依從站ESI說明設置), 第二個參數為週期時間(單位ns)
            Console.WriteLine("ECM_EcatInit return {0}", nRet); //return 1 代表 Init成功
            #endregion

            #region get slave info and set fifo
            nSlvCntOnline = ECM_EcatSlvCntGet();
            Console.WriteLine("Found {0} slave(s)", nSlvCntOnline);
            for (byte i = 0; i < nSlvCntOnline; i++)
            {
                nRet = ECM_SlaveInfoGet(i, ECM_SLV_INFO.ALstatuscode, ref u32InfoBuf);
                if (nRet > 0) //nRet: Slave Information Size
                {
                    if (u32InfoBuf != 0)
                    {
                        Console.WriteLine("Slave:{0} AL StatusCode:{1}...", i, u32InfoBuf); //AL StatusCode 非0 代表該Slave存在錯誤
                    }
                }
                else
                {
                    Console.WriteLine("Slave {0} Get AL StatusCode failed...", i);
                }
            }

            ECM_SetTxFIFOCnt(u8TxFIFOCnt); //Slave -> Master
            ECM_SetRxFIFOCnt(u8RxFIFOCnt); //Master -> Slave
            ECM_InitFIFO();
            // RxPDOSize MUST be the same as RxPDO struct size
            u16RxPDOSize = ECM_FifoRxPdoSizeGet();
            Console.Write("RxPDOSize {0} Byte(s), RxPDO struct size {1}\n", u16RxPDOSize, System.Runtime.InteropServices.Marshal.SizeOf(cmdData));
            // TxPDOSize MUST be the same as TxPDO struct size
            u16TxPDOSize = ECM_FifoTxPdoSizeGet();
            Console.Write("TxPDOSize {0} Byte(s), TxPDO struct size {1}\n", u16TxPDOSize, System.Runtime.InteropServices.Marshal.SizeOf(respData));

            nRet = ECM_EcatStateUpdate();
            if (nRet <= 0)
            {
                Console.Write("ECM_EcatStateUpdate fail({0})\n", nRet);
            }
            else
            {
                Console.Write("ECM_EcatStateUpdate done\n");
            }
            for (byte i = 0; i < nSlvCntOnline; i++)
            {
                nRet = ECM_EcatStateGet(i, ref u8TmpEcState);
                if (nRet > 0)
                {
                    Console.Write("slave {0} EcState:0x{1:X}\n", i, u8TmpEcState); // u8TmpEcState: 1 Init, 2 preOP, 4 SafeOP, 8 OP
                }
            }

            Console.Write("Any key to continue\n");
            Console.ReadKey();
            #endregion
            #region FoE for slave 0
            const uint GENERIC_READ = 0x80000000;
            const uint OPEN_ALWAYS = 4;
            const uint FILE_ATTRIBUTE_NORMAL = 0x80;
            int lpFileSizeHigh;
            UInt32 fsize;
            ECM_EcatStateSet(0xFF, EC_STATE_INIT);
            System.Threading.Thread.Sleep(1000);
            ECM_EcatStateSet(0, EC_STATE_BOOT); // slave 0 to BOOT mode
            System.Threading.Thread.Sleep(1000);
            string fileName = "ECATFW__";

            Microsoft.Win32.SafeHandles.SafeFileHandle fd = CreateFileA(fileName, GENERIC_READ, 0, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, IntPtr.Zero);

            fsize = GetFileSize(fd, out lpFileSizeHigh); // File size must < 256K 
            if (fsize == 0)
            {
                Console.WriteLine(String.Format("fileSize = {0}, File NOT Found. \r\nAny key to finish.", fsize));
                Console.ReadKey();
                return;
            }
            else
            {
                Console.WriteLine(String.Format("fileSize = {0}\r\nAny key to Start the FoE Download.", fsize));
                Console.ReadKey();
            }
            Console.WriteLine("=== Start the FoE Download.===");
            FoEDownload(0, fileName, 0, fsize, 256, fd, 1000000); // blockSize must <= 256. SPI Data Size must > blockSize if using SPI interface
            System.Threading.Thread.Sleep(1000);
            CloseHandle(fd);

            Console.WriteLine("============================\r\n Any key to finish.");
            Console.ReadKey();
            #endregion

            #region control state to Init and clsoe the system
            ECM_EcatStateSet(0xFF, EC_STATE_INIT);
            System.Threading.Thread.Sleep(100);
            ECM_CloseLibrary();
            UserSys_Close();
            #endregion
        }
        private static int SetPDOInfo(PDO_CONFIG_HEAD pdoInfo)
        {
            int nret;
            UInt32 u32Tmp;
            if (pdoInfo.SmaIdx != 0x1C12 && pdoInfo.SmaIdx != 0x1C13)
                return -1;
            // clear pdo count
            byte zero = 0;
            nret = ECM_EcatSdoWrite(pdoInfo.slave, pdoInfo.SmaIdx, 0, sizeof(byte), 10000000, ref zero);
            if (nret <= 0)
            {
                return -2;
            }
            for (byte nPdoIdx = 0; nPdoIdx < pdoInfo.PDOCnt; nPdoIdx++)
            {
                if (pdoInfo.ObjsCnt[nPdoIdx] > 0)
                {
                    nret = ECM_EcatSdoWrite(pdoInfo.slave, pdoInfo.MapIdx[nPdoIdx], 0, sizeof(byte), 10000000, ref zero);
                    for (byte nObjIdx = 0; nObjIdx < pdoInfo.ObjsCnt[nPdoIdx]; nObjIdx++)
                    {
                        u32Tmp = (UInt32)((pdoInfo.Table[nPdoIdx, nObjIdx].u16Idx * 0x10000) + (pdoInfo.Table[nPdoIdx, nObjIdx].u8SubIdx * 0x100) + (pdoInfo.Table[nPdoIdx, nObjIdx].u8BitSize));
                        nret = ECM_EcatSdoWrite(pdoInfo.slave, pdoInfo.MapIdx[nPdoIdx], (byte)(1 + nObjIdx), sizeof(UInt32), 10000000, ref u32Tmp);
                        if (nret <= 0)
                        {
                            return -3;
                        }
                    }
                    nret = ECM_EcatSdoWrite(pdoInfo.slave, pdoInfo.MapIdx[nPdoIdx], 0, sizeof(byte), 10000000, ref pdoInfo.ObjsCnt[nPdoIdx]);
                    if (nret <= 0)
                    {
                        return -4;
                    }
                }
                nret = ECM_EcatSdoWrite(pdoInfo.slave, pdoInfo.SmaIdx, (byte)(1 + nPdoIdx), sizeof(UInt16), 10000000, ref pdoInfo.MapIdx[nPdoIdx]);
                if (nret <= 0)
                {
                    return -5;
                }

            }
            nret = ECM_EcatSdoWrite(pdoInfo.slave, pdoInfo.SmaIdx, 0, sizeof(byte), 10000000, ref pdoInfo.PDOCnt);
            if (nret <= 0)
            {
                return -6;
            }
            return 0;
        }
    }
}
